generate infra test pipeline:
  stage: build
  image: registry.gitlab.com/opencraft/dev/grove/${TOOLS_CONTAINER_IMAGE_NAME}:${TOOLS_CONTAINER_IMAGE_VERSION}
  script:
    - grove pipeline "[AutoDeploy][Infrastructure]" generated-infra-create.yml
    - grove pipeline "[AutoDeploy][Infrastructure][Destroy]" generated-infra-destroy.yml
  artifacts:
    paths:
      - generated-infra-create.yml
      - generated-infra-destroy.yml
  rules:
    - if: $RUN_INFRA_TEST == "true"
    - if: $RUN_INFRA_TEST_DESTROY == "true"

infra test create:
  stage: test
  needs: ["generate infra test pipeline"]
  trigger:
    include:
      - artifact: generated-infra-create.yml
        job: generate infra test pipeline
    strategy: depend
  variables:
    TF_VAR_vpc_ip_range: $TEST_VPC_IP_RANGE
    TF_VAR_cluster_name: '${TF_VAR_cluster_provider}-infratest'
    GITLAB_TOFU_STATE_NAME: tf-state-${TF_VAR_cluster_provider}-infratest
  rules:
    - if: $RUN_INFRA_TEST == "true"

infra test destroy:
  stage: test
  needs: ["infra test create"]
  trigger:
    include:
      - artifact: generated-infra-destroy.yml
        job: generate infra test pipeline
    strategy: depend
  variables:
    TF_VAR_vpc_ip_range: $TEST_VPC_IP_RANGE
    TF_VAR_cluster_name: '${TF_VAR_cluster_provider}-infratest'
    GITLAB_TOFU_STATE_NAME: tf-state-${TF_VAR_cluster_provider}-infratest
  rules:
    - if: $RUN_INFRA_TEST == "true"

infra test force destroy:
  stage: test
  trigger:
    include:
      - artifact: generated-infra-destroy.yml
        job: generate infra test pipeline
    strategy: depend
  variables:
    TF_VAR_vpc_ip_range: $TEST_VPC_IP_RANGE
    TF_VAR_cluster_name: '${TF_VAR_cluster_provider}-infratest'
    GITLAB_TOFU_STATE_NAME: tf-state-${TF_VAR_cluster_provider}-infratest
  rules:
    - if: $RUN_INFRA_TEST_DESTROY == "true"
